/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package deBroigle;

import java.awt.Canvas;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;
import java.net.URL;
import javax.imageio.ImageIO;

/**
 *
 * @author Mikulas_s_capicu
 */
public class DeBroigleCanvas extends Canvas {

    Image prekazka;
    boolean kresliGulicku = true;
    int stredGulickyX = 143;
    int polomer = 8;
    int suradnicaY = 150;
    int zaciatocnyBod = 39;
    int koncovyBod = 570-41;
    int[] suradniceXVlny = {100, 105, 110, 115, 120, 125, 130, 135, 140,
                            145, 150, 155, 160, 165, 170, 175 ,180, 185};
    int[] okamziteVychylky = {0, -5, 5, -5, 5, -9, 18, -25, 30, -30,
                              25, -18, 9, -5 ,5, -5, 5, 0};
    int[] zaciatocneSuradniceYVlny = new int[18];
    int[] okamziteSuradniceYVlny = new int[18];
    int zacBod = 100;
    int rozostup = 4;

    public DeBroigleCanvas(){
        try {
            URL cesta = getClass().getResource("prekazka.png");
            prekazka = ImageIO.read(cesta);
        } catch (Exception e) {
            System.out.println(e.getMessage());
        }
        for(int i=0; i<zaciatocneSuradniceYVlny.length;i++){
            zaciatocneSuradniceYVlny[i] = okamziteVychylky[i] + suradnicaY;
        }
        okamziteSuradniceYVlny = zaciatocneSuradniceYVlny.clone();
    }

    @Override
    public void paint(Graphics g) {
        Dimension size = getSize();
        Image offscreen = createImage(size.width, size.height);
        Graphics bufferGraphics = offscreen.getGraphics();

        if (kresliGulicku){
            bufferGraphics.fillOval(stredGulickyX-polomer, suradnicaY-polomer, 2*polomer, 2*polomer);
        }else{
            bufferGraphics.drawLine(zaciatocnyBod, suradnicaY,
                                    suradniceXVlny[0], suradnicaY);
            bufferGraphics.drawPolyline(suradniceXVlny, okamziteSuradniceYVlny, okamziteSuradniceYVlny.length);
            bufferGraphics.drawLine(suradniceXVlny[suradniceXVlny.length-1], suradnicaY,
                                    koncovyBod, suradnicaY);
        }

        bufferGraphics.setColor(new Color(240, 240, 240));
        bufferGraphics.fillRect(0, 0, zaciatocnyBod , size.height);
        bufferGraphics.fillRect(koncovyBod, 0, zaciatocnyBod , size.height);
        bufferGraphics.drawImage(prekazka, 0, 0, this);
        bufferGraphics.drawImage(prekazka, koncovyBod, 0, this);
        bufferGraphics.setColor(Color.black);
  
        g.drawImage(offscreen, 0, 0, this);
    }

    @Override
    public void update(Graphics g) {
        paint(g);
    }

}