/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package doubleSlit;

import java.awt.Canvas;
import java.awt.Graphics;
import java.awt.Image;
import java.net.URL;
import javax.imageio.ImageIO;

/**
 *
 * @author Mikulas_s_capicu
 */
public class DoubleSlitAparatura extends Canvas {

    private Image aparatura;
    int koniecUseciek = 112;
    boolean animujUsecky = false;
    boolean animujKruznice = false;
    PolomerArrayList polomeryKruznic = new PolomerArrayList();

    public DoubleSlitAparatura(){
        try{
            URL cesta = getClass().getResource("DS.png");
            aparatura = ImageIO.read(cesta);
        }catch(Exception e){
            System.out.println(e.getMessage());
        }
    }

    @Override
    public void paint(Graphics g) {

        Image offscreen = createImage(getSize().width, getSize().height);
        Graphics bufferGraphics = offscreen.getGraphics();

        bufferGraphics.drawImage(aparatura, 0, 0, this);
        if (animujUsecky){
            bufferGraphics.drawLine(koniecUseciek, 60, koniecUseciek-65, 60);
            bufferGraphics.drawLine(koniecUseciek, 86, koniecUseciek-65, 86);
            bufferGraphics.drawLine(koniecUseciek, 112, koniecUseciek-65, 112);
            bufferGraphics.drawLine(koniecUseciek, 138, koniecUseciek-65, 138);
            bufferGraphics.drawLine(koniecUseciek, 166,koniecUseciek-65, 166);
            bufferGraphics.drawLine(koniecUseciek, 192,koniecUseciek-65, 192);
        }

        if (animujKruznice){
            polomeryKruznic.paint(bufferGraphics);
        }
        


        g.drawImage(offscreen, 0, 0, this);
    }

    @Override
    public void update(Graphics g) {
    	paint(g);
    }
}
